#include "wave.h"

double residual(Array2_dbl &u,double t,double dx, double dy, int nx1,
		int ny1, MPI_Comm proc_grid)
{
  int Nx,Ny,i,j;
  double sum,x,y,v,buf;
  Nx=u.storleken1(); Ny=u.storleken2();

  sum=0.0; 
  for (i=1; i<Nx-1; i++)
    for (j=1; j<Ny-1; j++)
      {
        x=(nx1+i-1)*dx; y=(j-1+ny1)*dy;
        v=h(x+y-2*t)+up(x,y);
        sum=sum+(u(i,j)-v)*(u(i,j)-v);
      }
  MPI_Allreduce(&sum,&buf,1,MPI_DOUBLE,MPI_SUM,proc_grid);
  return sqrt(buf*dx*dy);
}
